commit 0c7ed2bd961626697fb0962dce86d2141dc50d7f
Author: freddy77 <freddy77>
Date:   Fri Oct 24 08:29:22 2008 +0000

    more SQL_C_WCHAR works

diff --git a/ChangeLog b/ChangeLog
index 733fe6a..42daf9a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,14 @@
+Fri Oct 24 10:27:54 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* TODO.freddy: update
+	* src/odbc/sql2tds.c: fix SQL_NTS for SQL_C_WCHAR
+	* src/odbc/sqlwchar.c: optimize
+	* src/odbc/unittests/cancel.c: avoid valgrind error
+	* src/odbc/unittests/genparams.c:
+	- add check for SQL_NTS
+	- add check for NUMERIC
+	- add note
+	- rename Test function to TestOutput
+
 Thu Oct 23 17:09:26 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/sql2tds.c src/odbc/unittests/genparams.c:
 	- improve some conversions from SQL_C_WCHAR
@@ -766,4 +777,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2637 2008/10/23 15:09:29 freddy77 Exp $
+$Id: ChangeLog,v 1.2638 2008/10/24 08:29:22 freddy77 Exp $
diff --git a/TODO.freddy b/TODO.freddy
index 796d40c..bdb3a70 100644
--- a/TODO.freddy
+++ b/TODO.freddy
@@ -51,7 +51,6 @@ test to review
 - genparams.c
 - getdata.c ??
 - putdata.c ??
-- wchar.c
 - blob1.c (SQLGetData test with binary -> char and between chars)
 Is it possible to support direct binding for parameters using different
 encodings? For instance client <-> server iso8859-1 <-> ucs2. It should be
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index e48ad3a..56595ac 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.76 2008/10/23 15:09:29 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.77 2008/10/24 08:29:22 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -262,7 +262,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 			return SQL_ERROR;
 		}
 		if (sql_src_type == SQL_C_WCHAR)
-			len = sqlwcslen((const SQLWCHAR *) src);
+			len = sqlwcslen((const SQLWCHAR *) src) * sizeof(SQLWCHAR);
 		else
 			len = strlen(src);
 		break;
diff --git a/src/odbc/sqlwchar.c b/src/odbc/sqlwchar.c
index 61eb5a7..bcaf1c1 100644
--- a/src/odbc/sqlwchar.c
+++ b/src/odbc/sqlwchar.c
@@ -26,15 +26,16 @@
 
 #include "tdsodbc.h"
 
-TDS_RCSID(var, "$Id: sqlwchar.c,v 1.1 2008/02/05 09:46:33 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sqlwchar.c,v 1.2 2008/10/24 08:29:22 freddy77 Exp $");
 
 #if SIZEOF_SQLWCHAR != SIZEOF_WCHAR_T
 size_t sqlwcslen(const SQLWCHAR * s)
 {
-	size_t res = 0;
-	while (*s)
-		++s, ++res;
-	return res;
+	const SQLWCHAR *p = s;
+
+	while (*p)
+		++p;
+	return p - s;
 }
 #endif
 
diff --git a/src/odbc/unittests/cancel.c b/src/odbc/unittests/cancel.c
index 3fa879d..6de5f97 100644
--- a/src/odbc/unittests/cancel.c
+++ b/src/odbc/unittests/cancel.c
@@ -49,7 +49,7 @@ sigalrm_handler(int s)
 
 	printf(">>>> SQLCancel() ...\n");
 	CHK(SQLCancel, (Statement));
-	printf(">>>> ... SQLCancel done rcode = %d\n", rcode);
+	printf(">>>> ... SQLCancel done\n");
 
 	alarm(4);
 	signal(SIGALRM, exit_forced);
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 13951c0..15e91c9 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -4,22 +4,36 @@
 
 /* Test various type from odbc and to odbc */
 
-static char software_version[] = "$Id: genparams.c,v 1.33 2008/10/23 15:26:53 freddy77 Exp $";
+/*
+ * This test is useful to test odbc_sql2tds function using TestInput
+ * odbc_sql2tds have some particular cases:
+ * (1) char    -> char     handled differently with encoding problems DONE
+ * (2) date    -> *        different format
+ * (3) numeric -> *        different format DONE
+ * (4) *       -> numeric  take precision and scale from ipd
+ * (5) *       -> char     test wide
+ * (6) *       -> blob     test wchar and ntext
+ * (7) *       -> binary   test also with wchar
+ * (8) binary  -> *        test aldo with wchar
+ * Also we have to check normal char and wide char
+ */
+
+static char software_version[] = "$Id: genparams.c,v 1.34 2008/10/24 08:29:22 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
-static const int tds_no_dm = 1;
+static const char tds_no_dm = 1;
 #else
-static const int tds_no_dm = 0;
+static const char tds_no_dm = 0;
 #endif
 
-static int precision = 18;
-static int exec_direct = 0;
-static int prepare_before = 0;
-static int use_cursors = 0;
+static char precision = 18;
+static char exec_direct = 0;
+static char prepare_before = 0;
+static char use_cursors = 0;
 
 static void
-Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, SQLSMALLINT out_sql_type, const char *expected)
+TestOutput(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, SQLSMALLINT out_sql_type, const char *expected)
 {
 	char sbuf[1024];
 	unsigned char out_buf[256];
@@ -97,7 +111,8 @@ Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, SQL
 	Command(Statement, "drop proc spTestProc");
 }
 
-static int check_truncation = 0;
+static char check_truncation = 0;
+static char use_nts = 0;
 
 static void
 TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, const char *param_type, const char *value_to_convert)
@@ -128,6 +143,10 @@ TestInput(SQLSMALLINT out_c_type, const char *type, SQLSMALLINT out_sql_type, co
 		ODBC_REPORT_ERROR("Row not expected");
 	if (SQLMoreResults(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Recordset not expected");
+	if (use_nts) {
+		out_len = SQL_NTS;
+		use_nts = 0;
+	}
 
 	/* create a table with a column of that type */
 	ResetStatement();
@@ -208,20 +227,20 @@ AllTests(void)
 
 	/* FIXME why should return 38 0 as precision and scale ?? correct ?? */
 	precision = 18;
-	Test("NUMERIC(18,2)", "123", SQL_C_NUMERIC, SQL_NUMERIC, "18 0 1 7B");
-	Test("DECIMAL(18,2)", "123", SQL_C_NUMERIC, SQL_DECIMAL, "18 0 1 7B");
+	TestOutput("NUMERIC(18,2)", "123", SQL_C_NUMERIC, SQL_NUMERIC, "18 0 1 7B");
+	TestOutput("DECIMAL(18,2)", "123", SQL_C_NUMERIC, SQL_DECIMAL, "18 0 1 7B");
 	precision = 38;
-	Test("NUMERIC(18,2)", "123", SQL_C_NUMERIC, SQL_NUMERIC, "38 0 1 7B");
+	TestOutput("NUMERIC(18,2)", "123", SQL_C_NUMERIC, SQL_NUMERIC, "38 0 1 7B");
 	TestInput(SQL_C_LONG, "INTEGER", SQL_VARCHAR, "VARCHAR(20)", "12345");
 	/* MS driver behavior for output parameters is different */
 	if (driver_is_freetds())
-		Test("VARCHAR(20)", "313233", SQL_C_BINARY, SQL_VARCHAR, "333133323333");
+		TestOutput("VARCHAR(20)", "313233", SQL_C_BINARY, SQL_VARCHAR, "333133323333");
 	else
-		Test("VARCHAR(20)", "313233", SQL_C_BINARY, SQL_VARCHAR, "313233");
+		TestOutput("VARCHAR(20)", "313233", SQL_C_BINARY, SQL_VARCHAR, "313233");
 	/* FIXME our driver ignore precision for date */
 	precision = 3;
-	Test("DATETIME", "2004-02-24 15:16:17", SQL_C_BINARY, SQL_TIMESTAMP, big_endian ? "0000949700FBAA2C" : "979400002CAAFB00");
-	Test("SMALLDATETIME", "2004-02-24 15:16:17", SQL_C_BINARY, SQL_TIMESTAMP,
+	TestOutput("DATETIME", "2004-02-24 15:16:17", SQL_C_BINARY, SQL_TIMESTAMP, big_endian ? "0000949700FBAA2C" : "979400002CAAFB00");
+	TestOutput("SMALLDATETIME", "2004-02-24 15:16:17", SQL_C_BINARY, SQL_TIMESTAMP,
 	     big_endian ? "0000949700FB9640" : "979400004096FB00");
 	TestInput(SQL_C_TYPE_TIMESTAMP, "DATETIME", SQL_TYPE_TIMESTAMP, "DATETIME", "2005-07-22 09:51:34");
 
@@ -271,6 +290,7 @@ AllTests(void)
 	TestInput(SQL_C_UTINYINT, "TINYINT", SQL_TINYINT, "TINYINT", "231");
 
 	TestInput(SQL_C_NUMERIC, "NUMERIC(20,3)", SQL_NUMERIC, "NUMERIC(20,3)", "765432.2 -> 765432");
+	TestInput(SQL_C_NUMERIC, "NUMERIC(20,3)", SQL_VARCHAR, "VARCHAR(20)", "578246.234 -> 578246");
 
 	TestInput(SQL_C_BIT, "BIT", SQL_BIT, "BIT", "0");
 	TestInput(SQL_C_BIT, "BIT", SQL_BIT, "BIT", "1");
@@ -284,13 +304,13 @@ AllTests(void)
 
 	precision = 6;
 	/* output from char with conversions */
-	Test("VARCHAR(20)", "foo test", SQL_C_CHAR, SQL_VARCHAR, "6 foo te");
+	TestOutput("VARCHAR(20)", "foo test", SQL_C_CHAR, SQL_VARCHAR, "6 foo te");
 	/* TODO use collate in sintax if available */
-	Test("VARCHAR(20)", "0xf8f9", SQL_C_CHAR, SQL_VARCHAR, "2 \xf8\xf9");
+	TestOutput("VARCHAR(20)", "0xf8f9", SQL_C_CHAR, SQL_VARCHAR, "2 \xf8\xf9");
 
 	/* TODO some Sybase versions */
 	if (db_is_microsoft() && (strncmp(version, "08.00.", 6) == 0 || strncmp(version, "09.00.", 6) == 0)) {
-		Test("BIGINT", "-987654321065432", SQL_C_BINARY, SQL_BIGINT, big_endian ? "FFFC7DBBCF083228" : "283208CFBB7DFCFF");
+		TestOutput("BIGINT", "-987654321065432", SQL_C_BINARY, SQL_BIGINT, big_endian ? "FFFC7DBBCF083228" : "283208CFBB7DFCFF");
 		TestInput(SQL_C_SBIGINT, "BIGINT", SQL_BIGINT, "BIGINT", "-12345678901234");
 		TestInput(SQL_C_CHAR, "NVARCHAR(100)", SQL_WCHAR, "NVARCHAR(100)", "test");
 		/* test for invalid stream due to truncation*/
@@ -305,16 +325,20 @@ AllTests(void)
 		TestInput(SQL_C_LONG, "INT", SQL_WVARCHAR, "NVARCHAR(100)", "45236");
 
 		precision = 6;
-		Test("NVARCHAR(20)", "foo test", SQL_C_CHAR, SQL_WVARCHAR, "6 foo te");
+		TestOutput("NVARCHAR(20)", "foo test", SQL_C_CHAR, SQL_WVARCHAR, "6 foo te");
 		precision = 12;
-		Test("NVARCHAR(20)", "foo test", SQL_C_CHAR, SQL_WVARCHAR, "8 foo test");
+		TestOutput("NVARCHAR(20)", "foo test", SQL_C_CHAR, SQL_WVARCHAR, "8 foo test");
 		/* TODO use collate in sintax if available */
-		Test("NVARCHAR(20)", "0xf800f900", SQL_C_CHAR, SQL_WVARCHAR, "2 \xf8\xf9");
+		TestOutput("NVARCHAR(20)", "0xf800f900", SQL_C_CHAR, SQL_WVARCHAR, "2 \xf8\xf9");
 
 		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_WVARCHAR, "NVARCHAR(10)", "1EasyTest2");
+		use_nts = 1;
+		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_WVARCHAR, "NVARCHAR(10)", "1EasyTest3");
 		TestInput(SQL_C_WCHAR, "NVARCHAR(3)", SQL_WVARCHAR, "NVARCHAR(3)", "0xf800a300bc06");
 
+#ifdef ENABLE_DEVELOPING
 		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_INTEGER, "INT", " -423785  -> -423785");
+#endif
 	}
 }
 

